#include <bits/stdc++.h>
using namespace std;

int parent[1000001], size[1000001];

int root(int u) {
    if (u == parent[u]) return u;
    return parent[u] = root(parent[u]);
}

int allowed = 1;
multiset <int> mst;

void connect(int u, int v) {
    u = root(u);
    v = root(v);

    if (u == v) {
        allowed++;
        return;
    }

    if (size[u] > size[v]) swap(u, v);

    mst.erase(mst.find(-size[u]));
    mst.erase(mst.find(-size[v]));

    parent[u] = v;
    size[v] += size[u];

    mst.insert(-size[v]);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) {
        parent[i] = i;
        size[i] = 1;

        mst.insert(-1);
    }

    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        connect(a, b);

        int ans = 0, br = 0;

        for (auto it = mst.begin(); it != mst.end() && br < allowed; it++, br++) {
            ans -= (*it);
        }

        cout << ans - 1 << '\n';
    }

    return 0;

}
