#include <bits/stdc++.h>
using namespace std;

long long a[4000001], segment[16000001], lazy[16000001];
long long n, MOD;

long long build(long long idx, long long l, long long r) {
    if (l == r) return segment[idx] = a[l];
    long long m = (l + r) / 2;

    return segment[idx] = (build(2 * idx, l, m) + build(2 * idx, m + 1, r)) % MOD;
}

void push_lazy(long long idx, long long l, long long r) {
    lazy[idx] %= MOD;
    if (lazy[idx] == 0 || l == r) return;

    long long m = (l + r) / 2;
    segment[2 * idx] += lazy[idx] * (m - l + 1);
    segment[2 * idx + 1] += lazy[idx] * (r - m);
    lazy[2 * idx] += lazy[idx];
    lazy[2 * idx + 1] += lazy[idx];

    segment[2 * idx] %= MOD;
    segment[2 * idx + 1] %= MOD;
    lazy[idx] = 0;
}

long long query(long long idx, long long l, long long r, long long ql, long long qr) {
    if (qr < l || r < ql) return 0;
    if (ql <= l && r <= qr) return segment[idx];

    push_lazy(idx, l, r);
    long long m = (l + r) / 2;
    return (query(2 * idx, l, m, ql, qr) + query(2 * idx + 1, m + 1, r, ql, qr)) % MOD;
}

long long update(long long idx, long long l, long long r, long long ql, long long qr, long long x) {
    if (qr < l || r < ql) return segment[idx];
    if (ql <= l && r <= qr) {
        lazy[idx] += x;
        return segment[idx] = (segment[idx] + (r - l + 1) * x) % MOD;
    }

    push_lazy(idx, l, r);
    long long m = (l + r) / 2;
    return segment[idx] = (update(2 * idx, l, m, ql, qr, x) + update(2 * idx + 1, m + 1, r, ql, qr, x)) % MOD;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> MOD;

    vector <long long> f(1001);
    f[1] = 1;

    for (long long i = 2; i <= 1000; i++) {
        for (long long j = 1; j < i; j++) f[i] += f[i - j];
        for (long long j = 2; j <= i; j++) f[i] += f[i / j];

        update(1, 1, n, i, i, f[i]);
    }

    for (long long i = i + 1; i <= n; i++) {
        update(1, 1, n, i, i, query(1, 1, n, 1, i - 1));

        update(1, 1, n, 2 * i, n, query(1, 1, n, i, i));
    }

    cout << query(1, 1, n, n, n) << endl;
    return 0;

}
