#include <bits/stdc++.h>
using namespace std;

struct Position{
    int x, y, dir;

    Position() {x = y = dir = 0;}
    Position(int z, int t) : x(z), y(t) {dir = 0;}
    Position(int p, int q, int r) : x(p), y(q), dir(r) {}

    void operator()(char ds) {
        if (ds == '+') dir++;
        if (ds == '-') dir--;

        if (ds == 'F') {
            dir %= 4;
            dir = (dir + 4) % 4;

            if (dir == 0) x--;
            else if (dir == 1) y--;
            else if (dir == 2) x++;
            else if (dir == 3) y++;
        }
    }

    int manhattan() {
        return abs(x) + abs(y);
    }

    void rotate() {
        dir++;
        int temp = x;
        x = -y;
        y = temp;
    }

    void rotate(int x) {
        while (x--) rotate();
    }
};

Position operator+(Position a, Position b) {
    int howmanyrotate = ((a.dir - b.dir) % 4 + 4) % 4;
    b.rotate(howmanyrotate);

    return Position(a.x + b.x, a.y + b.y, b.dir);
}

Position operator-(Position a, Position b) {
    Position ans(b.x - a.x, b.y - a.y);

    return ans;
}

string arr = "+-F";

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    int n = s.size();

    vector <Position> v{Position(0, 0, 0)};

    int k;
    cin >> k;

    Position pos(0, 0);

    for (char ds : s) {
        pos(ds);
        v.push_back(pos);
    }

    int ans = 0;

    if (k == 0) {
        ans = v.back().manhattan();
    } else if (k == 1) {
        for (int i = 1; i <= n; i++) {
            for (int execution = 0; execution < 3; execution++) {
                Position first = v[i - 1], second = v[n] - v[i];
                first(arr[execution]);
                first = first + second;
                ans = max(ans, first.manhattan());
            }
        }
    } else {
        exit(1);
    }

    cout << ans << endl;
    return 0;

}
