#include <bits/stdc++.h>
using namespace std;

struct Position{
    long long x, y, dir;

    Position() {x = y = dir = 0;}
    Position(long long z, long long t) : x(z), y(t) {dir = 0;}
    Position(long long p, long long q, long long r) : x(p), y(q), dir(r) {}

    void operator()(char ds) {
        if (ds == '+') dir++;
        if (ds == '-') dir--;

        if (ds == 'F') {
            dir %= 4;
            dir = (dir + 4) % 4;

            if (dir == 0) x--;
            else if (dir == 1) y--;
            else if (dir == 2) x++;
            else if (dir == 3) y++;
        }
    }

    long long manhattan() {
        return abs(x) + abs(y);
    }

    void rotate() {
        dir++;
        long long temp = x;
        x = -y;
        y = temp;
    }

    void rotate(long long x) {
        while (x--) rotate();
    }
};

Position operator+(Position a, Position b) {
    long long howmanyrotate = ((a.dir - b.dir) % 4 + 4) % 4;
    b.rotate(howmanyrotate);

    return Position(a.x + b.x, a.y + b.y, b.dir);
}

Position operator-(Position b, Position a) {
    Position ans(b.x - a.x, b.y - a.y, b.dir - a.dir);

    return ans;
}

string arr = "+-F";

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    long long n = s.size();

    vector <Position> v{Position(0, 0, 0)};

    long long k;
    cin >> k;

    Position pos(0, 0);

    for (char ds : s) {
        pos(ds);
        v.push_back(pos);
    }

    long long ans = 0;

    if (k == 0) {
        ans = v.back().manhattan();
    } else if (k == 1) {
        for (long long i = 1; i <= n; i++) {
            for (long long execution = 0; execution < 3; execution++) {
                Position first = v[i - 1], second = v[n] - v[i];
                first(arr[execution]);
                first = first + second;
                ans = max(ans, first.manhattan());
            }
        }
    } else {
        exit(1);
    }

    cout << ans << endl;
    return 0;

}
