#include <bits/stdc++.h>
using namespace std;

struct Position{
    long long x, y, dir;

    Position() {x = y = dir = 0;}
    Position(long long z, long long t) : x(z), y(t) {dir = 0;}
    Position(long long p, long long q, long long r) : x(p), y(q), dir(r) {}

    void operator()(char ds) {
        if (ds == '+') dir++;
        if (ds == '-') dir--;

        if (ds == 'F') {
            dir %= 4;
            dir = (dir + 4) % 4;

            if (dir == 0) x--;
            else if (dir == 1) y--;
            else if (dir == 2) x++;
            else if (dir == 3) y++;
        }
    }

    long long manhattan() {
        return abs(x) + abs(y);
    }

    void rotate() {
        dir++;
        long long temp = x;
        x = -y;
        y = temp;
    }

    void rotate(long long x) {
        while (x--) rotate();
    }
};

Position operator+(Position a, Position b) {
    long long howmanyrotate = ((a.dir - b.dir) % 4 + 4) % 4;
    b.rotate(howmanyrotate);

    return Position(a.x + b.x, a.y + b.y, b.dir);
}

Position operator-(Position a, Position b) {
    Position ans(b.x - a.x, b.y - a.y, b.dir);

    return ans;
}

string arr = "+-F";

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    long long n = s.size();

    vector <Position> v;

    long long k;
    cin >> k;

    Position pos(0, 0);
    v.push_back(pos);

    for (char ds : s) {
        pos(ds);
        v.push_back(pos);
    }

    long long ans = 0;

    if (k == 0) {
        ans = v.back().manhattan();
    } else if (k == 1) {
        string save = s;
        long long mx = 0;

        for (char& ds : s) {
            for (char dss : arr) {
                ds = dss;
                Position current(0, 0, 0);

                for (int i = 0; i < n; i++) current(s[i]);
                mx = max(mx, current.manhattan());
            }

            s = save;
        }

        cout << mx << endl;
        return 0;
    } else {
        if (n <= 210) {
            string save = s;
            long long mx = 0;

            for (int i = 1; i < n; i++) {
                for (int j = 0; j < i; j++) {
                    for (char ds : arr) {
                        for (char dss : arr) {
                            if (s[i] == ds || s[j] == dss) continue;
                            s[i] = ds;
                            s[j] = dss;
                            Position current(0, 0, 0);

                            for (char dsss : s) current(dsss);
                            mx = max(mx, current.manhattan());

                            s = save;
                        }
                    }
                }
            }

            cout << mx << endl;
            return 0;
        }

        for (long long i = 1; i < n; i++) {
            for (long long j = i + 1; j <= n; j++) {
                for (long long execution = 0; execution < 3; execution++) {
                    for (long long exec2 = 0; exec2 < 3; exec2++) {
                        if (arr[execution] == s[i - 1] || arr[exec2] == s[j - 1]) continue;
                        Position first = v[i - 1], second = v[j - 1] - v[i], third = v[n] - v[j];
                        first(arr[execution]);
                        first = first + second;
                        first(arr[exec2]);
                        first = first + third;
                        ans = max(ans, first.manhattan());
                    }
                }
            }
        }
    }

    cout << ans << endl;
    return 0;

}
/**
F+F++F-F+F++F-
2
*/
