#include <bits/stdc++.h>
using namespace std;

string arr = "+-F", s;
struct Position{
    long long x, y, dir;

    Position() {x = y = dir = 0;}
    Position(long long z, long long t) : x(z), y(t) {dir = 0;}
    Position(long long p, long long q, long long r) : x(p), y(q), dir(r) {}

    Position operator()(char ds) {
        if (ds == '+') dir++;
        if (ds == '-') dir--;

        if (ds == 'F') {
            dir %= 4;
            dir = (dir + 4) % 4;

            if (dir == 0) x--;
            else if (dir == 1) y--;
            else if (dir == 2) x++;
            else if (dir == 3) y++;
        }

        return *this;
    }

    Position operator()(int x) {
        char ds = arr[x];
        if (ds == '+') dir++;
        if (ds == '-') dir--;

        if (ds == 'F') {
            dir %= 4;
            dir = (dir + 4) % 4;

            if (dir == 0) x--;
            else if (dir == 1) y--;
            else if (dir == 2) x++;
            else if (dir == 3) y++;
        }

        return *this;
    }

    long long manhattan() {
        return abs(x) + abs(y);
    }

    void rotate() {
        dir++;
        long long temp = x;
        x = -y;
        y = temp;
    }

    void rotate(long long x) {
        x = ((x % 4) + 4) % 4;
        while (x--) rotate();
    }
};

Position operator+(Position a, Position b) {
    b.rotate(a.dir);

    return Position(a.x + b.x, a.y + b.y, a.dir + b.dir);
}


Position dp[2001][3][3];

int solve2(int n) {
    long long ans = 0;

    for (int i = 1; i <= n; i++) {
        for (int symbol = 0; symbol < 3; symbol++) {
            if (symbol != s[i]) continue;
            dp[i][symbol][0] = dp[i - 1][s[i - 1]][0](symbol);
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int symbol = 0; symbol < 3; symbol++) {
            for (int prev = 0; prev < 3; prev++) {
                if (symbol == s[i]) {
                    dp[i][symbol][1] = dp[i - 1][prev][1];
                } else {
                    dp[i][symbol][1] = dp[i - 1][prev][0](symbol);
                }
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int symbol = 0; symbol < 3; symbol++) {
            for (int prev = 0; prev < 3; prev++) {
                if (symbol == s[i]) {
                    dp[i][symbol][2] = dp[i - 1][prev][2];
                } else {
                    dp[i][symbol][2] = dp[i - 1][prev][1](symbol);
                }

                ans = max(ans, dp[i][symbol][2].manhattan());
            }
        }
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    long long n = s.size();

    reverse(s.begin(), s.end());
    s.push_back(' ');
    reverse(s.begin(), s.end());

    long long k, ans = 0;
    cin >> k;

    vector <Position> v;

    Position pos(0, 0);
    v.push_back(pos);

    for (char ds : s) {
        pos(ds);
        v.push_back(pos);
    }

    if (k == 0) {
        ans = v.back().manhattan();
    } else if (k == 1) {
        string save = s;
        long long mx = 0;

        for (char& ds : s) {
            for (char dss : arr) {
                ds = dss;
                Position current(0, 0, 0);

                for (int i = 0; i < n; i++) current(s[i]);
                mx = max(mx, current.manhattan());
            }

            s = save;
        }

        cout << mx << endl;
        return 0;
    } else {
        if (n <= 210) {
            string save = s;
            long long mx = 0;

            for (int i = 1; i < n; i++) {
                for (int j = 0; j < i; j++) {
                    for (char ds : arr) {
                        for (char dss : arr) {
                            if (s[i] == ds || s[j] == dss) continue;
                            s[i] = ds;
                            s[j] = dss;
                            Position current(0, 0, 0);

                            for (char dsss : s) current(dsss);
                            mx = max(mx, current.manhattan());

                            s = save;
                        }
                    }
                }
            }

            cout << mx << endl;
            return 0;
        }

        solve2(n);
    }

    cout << ans << endl;
    return 0;

}

/**
F+F++F-F+F++F-
2
*/
